/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// body.h Fri Jun 8 2001
// Description:
//////////////////////////////////////////////////////////////////////

#ifndef _BODY_H_
#define _BODY_H_

#include "sensordata.h"
#include "identitydata.h"
#include "moveaction.h"
#include "dribbleaction.h"
#include "kickaction.h"
#include "turnneckaction.h"
#include "turnaction.h"
#include "playercomm.h"
#include "actionlist.h"

using namespace std;

class Body
{
public: 
	Body();
	virtual ~Body();

	//updates the state of the world
  void senseWorld();
  SensorData *getNextSensorData();
	
  //is done once at the beginning to get identity
	void init(IdentityData &_idAboutMe, const char* _pcHostName, int _iPort, int _iReconnectNumber);
	bool isConnected();
	bool hasSensorData();
	// senseIdentity();
	int execute(const Action* _pacAction); // special case
	int execute(); // pops local actionlist and executes
    int execute(const ActionList& alActions);
	
private:
	// a constant reference to the worldmodel for evaluating "rules"
	// when contacting the server (i.e. only
	PlayerComm cmConnection;
	SensorDataStore sdsSensoryInfo;
	ActionList alTheList;
};

#endif
