/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// changeviewaction.cpp Tue Jul 24 2001
// Description:
//////////////////////////////////////////////////////////////////////

#include "changeviewaction.h"

ChangeViewAction::ChangeViewAction()
{
	setViewQuality(VIEW_QUALITY_LOW); // used to be UNKNOWN
	setViewWidth(VIEW_WIDTH_NORMAL); // used to be UNKNOWN
}

ChangeViewAction::ChangeViewAction(view_width _vwWidth, view_quality _vqQuality)
{
	setViewWidth(_vwWidth);
	setViewQuality(_vqQuality);
}


ChangeViewAction::~ChangeViewAction()
{
}

ServerCommand* ChangeViewAction::translate() const
{
    ChangeViewCommand* cvcCommand = new ChangeViewCommand(vwWidth, vqQuality);

    return cvcCommand;
}


Action* ChangeViewAction::copy() const
{
    return new ChangeViewAction(*this);
}
	

void ChangeViewAction::setViewWidth(view_width _vwWidth)
{
	vwWidth = _vwWidth;
}

void ChangeViewAction::setViewQuality(view_quality _vqQuality)
{
	vqQuality = _vqQuality;
}

view_width ChangeViewAction::getViewWidth() const
{
	return vwWidth;
}

view_quality ChangeViewAction::getViewQuality() const
{
	return vqQuality;
}



ostream& ChangeViewAction::ostream_insert(ostream& _out) const
{
    _out << "ChangeViewAction";

    return _out;
}

ofstream& ChangeViewAction::ofstream_insert(ofstream& _fout) const
{
    _fout << "<changeviewaction/>" << endl;

    return _fout;
}


