/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// moveaction.h Mon Jun 11 2001
// Description:
//////////////////////////////////////////////////////////////////////

#ifndef _MOVEACTION_H_
#define _MOVEACTION_H_

#include "action.h"


class MoveAction : public Action
{
public: 
	MoveAction();
	MoveAction(double _dX, double _dY);
	MoveAction(Vector2d _vPosition);
	virtual ~MoveAction();
	virtual Action* copy() const;
	virtual ServerCommand* translate() const;

	void setPosition(double _dX, double _dY);
    void setPosition(Vector2d _vPosition);
	Vector2d getPosition() const;
	
    virtual ostream& ostream_insert(ostream& _out) const;
    virtual ofstream& ofstream_insert(ofstream& _fout) const;

private:
	Vector2d vPosition;
};

#endif
