/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// turnneckaction.cpp Thu Jun 21 2001
// Description:
//////////////////////////////////////////////////////////////////////

#include "turnneckaction.h"
#include "turnneckcommand.h"

TurnNeckAction::TurnNeckAction() : Action()
{
	setDuration(0);
}

TurnNeckAction::TurnNeckAction(const Angle &_aDirection) : Action()
{
	setDuration(0);
	setDirection(_aDirection);
}

TurnNeckAction::~TurnNeckAction()
{
}
Action* TurnNeckAction::copy() const
{
	return new TurnNeckAction(*this);
}

ServerCommand* TurnNeckAction::translate() const
{
	// WARNING: remember to delete this!
	TurnNeckCommand *ptncCmd = new TurnNeckCommand(getDirection());
	
	return ptncCmd;
}

void TurnNeckAction::setDirection(const Angle &_aDirection)
{
	aDirection = _aDirection;
}

Angle TurnNeckAction::getDirection() const
{
	return aDirection;
}



ostream& TurnNeckAction::ostream_insert(ostream& _out) const
{
    _out << "TurnNeckAction" << endl;

    return _out;
}


ofstream& TurnNeckAction::ofstream_insert(ofstream& _fout) const
{
    // TODO: Implement XML

    return _fout;
}
