/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// changeviewcommand.cpp Fri Jun 22 2001
// Description:
//////////////////////////////////////////////////////////////////////

#include "changeviewcommand.h"

#undef TRACE
#define TRACE(cmd)

ChangeViewCommand::ChangeViewCommand() : ServerCommand(0)
{
	setViewQuality(VIEW_QUALITY_LOW); // used to be UNKNOWN
	setViewWidth(VIEW_WIDTH_NORMAL); // used to be UNKNOWN
}

ChangeViewCommand::ChangeViewCommand(view_width _vwWidth, view_quality _vqQuality) : ServerCommand(0)
{
	setViewWidth(_vwWidth);
	setViewQuality(_vqQuality);
}

ChangeViewCommand::~ChangeViewCommand()
{
}

Comm& ChangeViewCommand::comm_insert(Comm &_cmConnection) const
{
	  char w[10] = "";
    switch (vwWidth)
    {
    case VIEW_WIDTH_NARROW:
        strcpy(w, "narrow");
        break;
    case VIEW_WIDTH_NORMAL:
        strcpy(w, "normal");
        break;
    case VIEW_WIDTH_WIDE:
        strcpy(w, "wide");
        break;
    }

    char q[10] = "";
    switch (vqQuality)
    {
    case VIEW_QUALITY_LOW:
        strcpy(q, "low");
        break;
    case VIEW_QUALITY_HIGH:
        strcpy(q, "high");
        break;
    }

    char msg[MAX_SERVER_MSG_SIZE];
    sprintf(msg, "(change_view %s %s)", w, q);
    if (_cmConnection.sendToServer(msg) == COMM_OK)
    {
        TRACE("PlayerComm: agent sent " << msg);
    }
    else
    {
        ALERT("servertime_here"
              << " PlayerComm: agent cannot send " << msg << " to server" );
    }


	return _cmConnection;
}

void ChangeViewCommand::setViewWidth(view_width _vwWidth)
{
	vwWidth = _vwWidth;
}

void ChangeViewCommand::setViewQuality(view_quality _vqQuality)
{
	vqQuality = _vqQuality;
}

view_width ChangeViewCommand::getViewWidth() const
{
	return vwWidth;
}

view_quality ChangeViewCommand::getViewQuality() const
{
	return vqQuality;
}
