/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// mastercontrol.h Fri Jun 8 2001
// Description:
//////////////////////////////////////////////////////////////////////

#ifndef _MASTERCONTROL_H_
#define _MASTERCONTROL_H_

#include "debug.h"
#include "recommendation.h"
#include "action.h"
#include "worldmodel.h"
#include "behavior.h"
//#include "selfmodel.h"
#include "perception.h"
#include "body.h"
#include "identitydata.h"
#include <iostream.h>
#include <strstream.h>
#include <stdlib.h>
#include <vector>

class MasterControl
{

public:
    MasterControl(char* _pcTeamname, const char* _pcHostName, int _iPort, bool _fLogging,
                  int _iReconnectNumber, bool _fIsGoalie = false);
	~MasterControl();
	void play();
	int listen();
	Recommendation think();
	int act(const Recommendation &_recFinal);

private:
	WorldModel wmWorld;

	vector<Behavior*> pbeBehaviors;
//	Perception* pperPerceptions[NUM_PERCEPTIONS];
	Body bdBody;
	// filestream for logging
	ofstream out;
	bool fLogging;

    /** For demonstration purposes only, REMOVE ME! */
    int iLastKickTime;
    bool fClockwise;

    // For logging
    int iLastTime;
    play_mode pmLastPlayMode;

};

#endif
