/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// catchperception.h Mon Jul 23 2001
// Description:
//////////////////////////////////////////////////////////////////////

#ifndef CATCHPERCEPTION_H
#define CATCHPERCEPTION_H

#include "perception.h"

/**Goalie's Catch Perception
  *@author UVa RoboCup Team
  */


class CatchPerception : public Perception  {
public: 
	CatchPerception(const WorldModel& _wmWorld);
	virtual ~CatchPerception();

	bool isBallOld() const;	
	bool isCatchable() const;	
	bool isActiveMode() const;	
	Angle catchAngle() const;
    bool inOurPenaltyArea() const;

private:
    static const int OLD_AGE;
};

#endif
