/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// freekickperception.h Tue Jul 24 2001
// Description:
//////////////////////////////////////////////////////////////////////

#ifndef _FREEKICKPERCEPTION_H_
#define _FREEKICKPERCEPTION_H_

#include "perception.h"

class FreeKickPerception : public Perception
{
public: 
	FreeKickPerception(const WorldModel& _wmWorld);
	virtual ~FreeKickPerception();
	bool isActiveMode() const;
	bool atBall() const;
	Angle angleToBackOfBall() const;
	bool isBehindBall() const;
	bool isNoOneBehindBall() const;
	bool isCloseToBall() const;
	Angle angleToKick() const;
	int getTime() const;
	
	// only need these
	Angle getRunAngle() const;
	bool inPosition() const;
	int getStamina() const { return (int)wmWorld.getClientPlayer().getStamina(); }
};

#endif


