
/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// gohomeperception.cpp Tue Jul 10 2001
// Description:
//////////////////////////////////////////////////////////////////////

// Note: HOME_POSITIONS[] defined in constants.h/.cpp

#include "gohomeperception.h"

GoHomePerception::GoHomePerception(const WorldModel &_wmWorld) : Perception(_wmWorld)
{
}

GoHomePerception::~GoHomePerception()
{
}

bool GoHomePerception::isTooFarFromHome(const Vector2d &_vHome) const
{
	return (relPos(_vHome).getLength() > 30.0);
}

bool GoHomePerception::isHome(const Vector2d &_vHome) const
{
	// Using KICKRANGE as a reasonable margin of proximity to home
	return (relPos(_vHome).getLength() < KICKRANGE);
}

bool GoHomePerception::isActiveMode() const
{
    play_mode pmTemp = wmWorld.getPlayMode();
    if( (pmTemp == PLAY_MODE_GOAL_KICK_US) ||
        (pmTemp == PLAY_MODE_CORNER_KICK_US)
        ) return true;

    return false;
}

bool GoHomePerception::atBall() const
{
	ClientWorldPlayer cwpClientPlayer = wmWorld.getClientPlayer();
	WorldBall wbBall = wmWorld.getWorldBall();
	
	return (dist(cwpClientPlayer, wbBall) < KICKRANGE);
}

