/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// gotocornerperception.h Sat Aug 4 2001
// Description:
//////////////////////////////////////////////////////////////////////

#ifndef GOTOCORNERPERCEPTION_H
#define GOTOCORNERPERCEPTION_H

#include "perception.h"

class GoToCornerPerception : public Perception
{
public: 
	GoToCornerPerception(const WorldModel& _wmWorld);
	virtual ~GoToCornerPerception();
	
	Angle angleToGoal() const;
	Angle angleToKick() const;
	bool atBall() const;
	bool ballMovingFaster();
	bool willPassBall(double _dDashPower = 20.0) const;
	bool ballAged() const;
	bool isOurGoalKick () const;
	bool inTopHalf () const;
private:
	Vector2d vLastVel;
	
	
};

#endif
