
/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// goalkickperception.h Tue Jul 24 2001
// Description:
//////////////////////////////////////////////////////////////////////

#ifndef PUNTPERCEPTION_H
#define PUNTPERCEPTION_H

#include "perception.h"

/**
  *@author UVa RoboCup Team
  */

class PuntPerception : public Perception  {
public: 
	PuntPerception(const WorldModel& _wmWorld);
	~PuntPerception();
	
	bool isActiveMode() const;
	bool isPlayModeCatch() const;
	bool sendMove() const; // as in, send a move instead of a run

    Vector2d getPuntLocation() const;
    Angle angleToKick() const;
	
	Vector2d closestTeammate() const;
	// dist from a point to closest opponent
	double distToClosestOpponent(Vector2d _vOrigin) const;
	
    bool atPuntLocation() const;
    bool inOurPenaltyArea() const;

    bool holdingBall() const;

    bool facingUpfield() const;

private:

    // coordinates of corners of penalty area
    Vector2d vUpperCorner;
    Vector2d vLowerCorner;	
};

#endif
