/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// scanperception.h Mon Jul 2 2001
// Description:
//////////////////////////////////////////////////////////////////////

#ifndef _SCANPERCEPTION_H_
#define _SCANPERCEPTION_H_

#include "perception.h"
#include "angle.h"


class ScanPerception : public Perception
{
public: 
	ScanPerception(const WorldModel &_wmWorld);
	virtual ~ScanPerception();
	int getWorldAge() const;
	bool isWorldUnknown() const;
	Angle angleToBall() const;
	bool isNeckTwisted() const;
	bool isBallNotInPlay() const;
	Angle relNeckAngle(const Angle& aAbsNeckPosition) const;
	bool isLookingAtBall() const;
	int getTime() const;
	double turnDirection() const;
	bool isKickOffMode() const;
};

#endif
