/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// shootbehavior.cpp Tue Jul 3 2001
// Description:
//////////////////////////////////////////////////////////////////////

#include "shootbehavior.h"
#include "kickaction.h"

ShootBehavior::ShootBehavior(const WorldModel &_wmWorld) : perShoot(_wmWorld)
{
}

ShootBehavior::~ShootBehavior()
{
}

bool ShootBehavior::isUseful()
{
  return (perShoot.atGoal() && perShoot.atBall());
}

void ShootBehavior::evaluate(RecommendationList& recList)
{
  Recommendation recShoot;
  
  KickAction kaKick;
  
  kaKick.setDirection(perShoot.getShotAngle());
  kaKick.setIntensity(100);
  
  recShoot.addAction(kaKick);
  recShoot.setGrade(perShoot.haveShot());
  
  recShoot.szBehaviorName = "shoot";
  recList.insert(recShoot);
}
