//////////////////////////////////////////////////////////////////////
// Mainz Rolling Brains RoboCup agents developed for the Simulator
// League of the RoboCup 2000 competition
//
// Copyright (C) 1998, 1999, 2000 Team Members
// of the Mainz Rolling Brains RoboCup Team
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//-*- c++ -*-/////////////////////////////////////////////////////////
//
//  $Id: datastore.cpp,v 1.3 2001/06/18 15:15:08 kmb3s Exp $
//
//  datastore.C - storing of SensorData
//
//////////////////////////////////////////////////////////////////////


#include "datastore.h"

SensorDataStore::SensorDataStore() : list<SensorData*>()
{
}

SensorDataStore::~SensorDataStore()
{
	// if there are still elements in the DataStore and deconstruction
	//	delete them to prevent memory leaks
	SensorData* sdDeleteMe = NULL;
	
	while (!empty())
	{
		sdDeleteMe = front();
		pop_front();
		delete sdDeleteMe;
	}
			
}


void SensorDataStore::insert(SensorData *data)
{
	// TODO: perhaps: place limits on different types of
	// SensorData.  Maintain a pointer to the least important
	// SensorData of each type, and the number of a given type
	// of SensorData.  That way we can delete the least important
	// sensordata but maintain the last 5 audio messages, 2 visual, etc.
	// In the more immediate future... make this insert into the list
	// in sorted order.  For now, just insert the data at the front, and
	// keep only the last 2.
	
	// if the list is too large delete the least important element
	if (size() > DATA_STORE_SIZE)
	{
		SensorData* sdTooOld = back();
		pop_back();
		delete sdTooOld;
	}

	// add the new element to the list
	push_front(data);
}
