/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// visualdata.h Wed Jun 13 2001
// Description:
//////////////////////////////////////////////////////////////////////

#ifndef _VISUALDATA_H_
#define _VISUALDATA_H_

#include "sensordata.h"
#include "sensor.h"

class VisualData : public SensorData  {
public: 
	VisualData();
	VisualData(int _time);	
	virtual ~VisualData();

    virtual ostream& ostream_insert(ostream &sout) const;
	virtual WorldModel& worldmodel_insert(WorldModel &_wmWorld) const;

    // from sensor.h
    // the following valid if type == SENSOR_TYPE_SEE
    SensorObject ball;
    SensorGoal goal[2];
    SensorPlayer player[NUM_OTHER_PLAYERS];
    SensorFlag flag[NUM_FLAGS];
    SensorLine line[NUM_LINES];
};

#endif
