/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// worldball.cpp Fri Jun 8 2001
// Description: WorldBall represents a ball in the WorldModel
//////////////////////////////////////////////////////////////////////

#include "worldball.h"

// TODO: replace these magic numbers with the proper #defines
WorldBall::WorldBall() : WorldMovableObject(100, 4)
{
    setKnown(); // the ball is always known, whether you see it or not
}

WorldBall::~WorldBall()
{
}

WorldBall& WorldBall::operator+=(const ExactObject &_eBall)
{
	// TODO: fix the fact that we're setting relative information
	//			 in this function, perhaps deprecate completely and
	//			 set all information in worldmodel
    if(_eBall.valid)
    {
        setAge(0);
        setAbsPosition(Vector2d(_eBall.x, _eBall.y));
        setVelocity(Vector2d(_eBall.x_vel, _eBall.y_vel));
     }

    return *this;
}

WorldBall& WorldBall::operator+=(const SensorObject &soBall)
{
// This function is deprecated!!!
/*	
	// if we saw the ball
	if (soBall.valid)
	{
		// first adjust the age and conetime
		setAge(0);
		increaseConeTime();
		
		// then update the velocity	
		//setVelocity(soBall.dir_change, soBall.dist_change);
	}
	
	else if(isKnown())
	{
		// set the cone time to zero and increase the age	
	    incrementAge();
		if (getAge() == 0) setConeTime(0);
	}
	*/
	
	return *this;
}

ostream& operator<<(ostream& _out, WorldBall &_wbBall)
{
  return _wbBall.ostream_insert(_out);
}
