/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// worldobject.h Thu Jun 7 2001
// Description: WorldObject represents an object in the worldmodel.
//							This is MRB Code
//////////////////////////////////////////////////////////////////////

#ifndef _WORLDOBJECT_H_
#define _WORLDOBJECT_H_

#include <fstream.h>
#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include "angle.h"
#include "vector2d.h"
#include "constants.h"
#include "sensor.h"

class WorldObject
{
public:
	WorldObject();
  WorldObject(const Vector2d& _vAbsPosition);
  virtual ~WorldObject();
	
	// get the age of a WorldObject
	int getAge() const;
	bool isKnown() const;	
	void setKnown() { fKnown = true; }
	// get the Absolute Position of a WorldObject
	Vector2d getAbsPosition() const;
	// set the Absolute Position of a WorldObject
	void setAbsPosition(const Vector2d &_vAbsPosition);
	// set the age of a WorldObject
	void setAge(int _iAge);
	void incrementAge();
	
	// Hmmm... not sure if these operators are necessary for
	// flags, lines, and goals
  WorldObject& operator+=(const SensorObject &soObject);
//	WorldObject& operator+=(const SensorGoal &sgGoal);
//	WorldObject& operator+=(const SensorFlag &sfFlag);
//	WorldObject& operator+=(const SensorLine &slLine);
	WorldObject& operator+=(const ExactGoal &_egGoal); // coach facility

	virtual ofstream& ofstream_insert(ofstream &_out);
	virtual ifstream& ifstream_extract(ifstream &_in);
			
private:	
  bool fKnown;                   // Track whether we've ever seen this thing before
  Vector2d vAbsPosition;	     // absolute position on the field
  int      iAge;   				 // number of simulation steps that have passed since this object
                   				 // has been updated

};



#endif
